// widz_apmon.c
//
// by FATBLOKE
//
// widz 1.9
// ---    Rewriiten to use driver based device scan 
// ---    
// widz 1.8
// This little program monitors an area for Access Points
// If finds an ap it compares it to a list stored in a config file
//
// if the AP isnt in list it calls a program called Alert with an
// appropriate message.  The example alert script sent a syslog
// message which in our example will be picked up by snort
// - but it could sent an snmp trap or a command.
//
// This is only a proof on concept - the development of which has been
// bogged down by a series of trials some technical, some managerial
// and emotional  - please see doc for suggested  improvements
//
//
//
#include "iwlib.h"
#include <ctype.h>
#include <syslog.h>
//  #include "iwcommon.h"
char wdev[16];
int sleeptime, count;
char *pattern[100];
FILE *ff;
FILE *YY;
int  DEBUG = 0;
int daemon_mode = 0 ; // NO            
char instancename[30]   ;


#define  MAXAP_CONST  99
#define   CONF_FILE  "widz-ap.config"
int      MAXAP =           MAXAP_CONST;
int      MAXDEV =           0          ;

#define       SIGNAL_OVERPOWER 1.2   // 20 percent margin of error

typedef struct widzap
{
char widz_essid[IW_ESSID_MAX_SIZE+1];
char widz_mac[16];
int widz_channel;
int widz_signal;
} widzap;
struct widzap aptable[MAXAP_CONST];
struct widzap devtable[MAXAP_CONST];


/*
 *	for dumping the frame in hex
 */
char *macit(__u8 * x)
{
    char mac[18];
    if ( DEBUG )
        fprintf(stderr, "Function:  %s \n", __FUNCTION__);
    sprintf (mac,"%02x:%02x:%02x:%02x:%02x:%02x", 
		    x[0], x[1], x[2], x[3], x[4], x[5]);
    return(strdup(mac));
}
/*
*************************************************
* Schedules a scan by card 
* results table collcted by later GET ioctl      
*************************************************
*/

int
schedule_scan(int skfd, char* ifname)
   {
   struct iwreq wrq;//the ioctl struct 
   //init the request
   if ( DEBUG )
      fprintf(stderr, "Function:  %s \n", __FUNCTION__);
    
    MAXDEV =           0          ;
    strncpy(wrq.ifr_name, ifname, IFNAMSIZ);
    wrq.u.data.pointer = NULL;
    wrq.u.data.flags = 0;
    wrq.u.data.length = 0;
    //send the ioctl request demanding the scan.

    if ( ioctl(skfd, SIOCSIWSCAN, &wrq) < 0)
        {
        if (errno == EPERM)
           {
           fprintf(stderr,
                      "Permission Error (rum the program as root)\n");
           exit(1);
           }
        else
           {
           fprintf(stderr,
                "Interface %s doesn't support scanning.\n", ifname);
           exit(1);
           }
         } 


   if ( DEBUG )
       fprintf(stderr, 
              "Scan sheduled successfully!\n");
    return 0;
}

/*
*************************************************
* Collects AP table from driver               
*************************************************
*/
 
int 
get_scan(int skfd, char* ifname, struct iwreq* wrq)
    {
    unsigned char* buffer = NULL;
    int buflen = IW_SCAN_MAX_DATA * 2; 
    int retry, 	ret;
   if ( DEBUG )
      fprintf(stderr, "Function:  %s \n", __FUNCTION__);
    
    for (retry=0; retry < 2 ; retry++)//scan until we break the loop ourselves
        {
		
         ret = sleep(5);
         if ( DEBUG )
             fprintf(stderr," sleep returned %i", ret);

		/* Check if there was an error */
	 if (ret < 0)
            {
            if(errno == EAGAIN || errno == EINTR)
				continue;
            fprintf(stderr, "Unhandled signal - exiting...\n");
			return(-1);
        	}

		/* Check if there was a timeout */
          unsigned char *	newbuf;
	  newbuf = realloc(buffer, buflen);
          if(newbuf == NULL)
	      {
	      if(buffer)
  	           free(buffer);
	      fprintf(stderr, "%s: Allocation failed\n", __FUNCTION__);
	      exit(-1);
              }
           buffer = newbuf;
	//init the iw request
           strncpy(wrq->ifr_name, ifname, IFNAMSIZ);
           wrq->u.data.flags = 0;
           wrq->u.data.pointer = buffer;
           wrq->u.data.length = buflen;
	/* Dothe request */
          if(ioctl(skfd, SIOCGIWSCAN, wrq) < 0)
             {
/* error  */
	     if (errno == EAGAIN)
                 {
                 fprintf(stderr, 
                      "Driver reguested ReTry (EAGAIN)!");
                 continue;	/* Try again */
                 }

	/* Bad error */
	      free(buffer);
		fprintf(stderr, "%-8.16s  Failed to read scan data : %s\n\n",
						ifname, strerror(errno));
		exit(-2);
		}//end if - error checking
	else
		{
                if ( DEBUG )
		    fprintf(stderr,"IOCTL ret  0 !\n");
		return 0;
		}
	}
return 0;
}

int got_essid, got_channel, got_mac, got_signal;
int driver_signal;
char driver_mac[16];                   
char driver_essid[IW_ESSID_MAX_SIZE+1];
int             channel = -1;           /* Converted to channel */


/*
 * process extracted element according to type
*  
 */
static inline int
do_iw_event(struct iw_event *	event,	/* Extracted token */
		struct iw_range *	iw_range,	/* Range info */
					int		has_range)
{
  char		buffer[128];	/* Temporary buffer */
  double          freq;                   /* Frequency/channel */
  char *tmp_mac_p;                   
   if ( DEBUG )
      fprintf(stderr, "Function:  %s \n", __FUNCTION__);
    
  if ( DEBUG )
      printf("Printing event. event->cmd=%x. ", event->cmd);
/* Now, let's decode the event */
  switch(event->cmd)
    {
    case SIOCGIWAP:
      tmp_mac_p        =             macit(event->u.ap_addr.sa_data);
      strcpy (driver_mac, tmp_mac_p);
      free  (tmp_mac_p);
      got_mac = 1;
      break;
   case SIOCGIWNWID:
// skip over element dont want it
      break;
   case SIOCGIWFREQ:
// there can be a freq 2.47mhz or chan 1
// dont know which so look at the value
if (got_channel == 0) 
  {
freq = iw_freq2float(&(event->u.freq));
  if ( freq < 30.0 )   // a channel record not a frequnecy  record
     {
     channel = ( int)  freq;
    got_channel = 1 ; 
      }
}
break;
   case SIOCGIWMODE:
// skip over MODE element dont want it
      break;
     if ( DEBUG )
        printf("mode\n");
     break;
    case SIOCGIWNAME:
// skip over NAME element dont want it
      break;
     if ( DEBUG )
       printf("name\n");
	break;
     case SIOCGIWESSID:
       memcpy(driver_essid, event->u.essid.pointer, event->u.essid.length);
       driver_essid[event->u.essid.length] = '\0';
       got_essid = 1   ;
	break;
     case SIOCGIWENCODE:
//  ENCRYPTION element  we will want it in the future
//  a change in algorithmn would be something we were interested in
//  but skip for now.
      break;
    case SIOCGIWRATE:
      if ( DEBUG )
        {
        iw_print_bitrate(buffer, sizeof(buffer), event->u.bitrate.value);
        printf("\t\tBit Rate:%s\n", buffer);
         }
       break;

     case IWEVQUAL:
        iw_print_stats(buffer, sizeof(buffer),
        &event->u.qual, iw_range, has_range);
        int dummy;
        sscanf(buffer," Quality:%i Signal level:%i ", &dummy, &driver_signal);
           got_signal = 1 ;
        if ( DEBUG )
           printf("\t\t%s\n", buffer);
	break;
      case IWEVCUSTOM:
        	break;
      default:
        if ( DEBUG )
           printf("\t\t(Unknown Wireless Token 0x%04X)\n", event->cmd);
	}	/* switch(event->cmd) */

  return(0);
}
/**
 * 
 * Use  iw_init_event_stream to initalise returned data as a stream 
 *  Then Use  iw_extract_event_stream to read event one at a time.
 * 
 */
print_scan_results(struct iwreq* wrq, char* ifname)
{
	struct iw_event		iwe;
	struct stream_descr	stream;
	int			ret;
        if ( DEBUG )
            fprintf(stderr, "Function:  %s \n", __FUNCTION__);
    
	
	/* init the event stream descriptor */
        memset((char *) &stream, '\0', 8 ); // kludge -  zero the header  
	stream.current = wrq->u.data.pointer;
	stream.end = wrq->u.data.pointer + wrq->u.data.length;
         // need to initalise the stream
        iw_init_event_stream(&stream, (char *) wrq->u.data.pointer, wrq->u.data.length);
	do
	{
		/* Extract an event from the stream */
	ret = iw_extract_event_stream(&stream, &iwe, 19);//we version - unused
	if(ret > 0)
	   do_iw_event(&iwe, NULL, 0);
        if ( ( got_essid+ got_mac+ got_signal +got_channel) ==4 )
           {
           if ( DEBUG )
             {
             printf("\t\tESSID:%s ", driver_essid);
             printf("AP\t\tAddress: %s", driver_mac);
             printf(" level:%d \n", driver_signal);
             printf(" chanl:%d \n", channel      );
             }
           got_signal = 0 ;
           got_mac = 0 ;
           got_essid = 0   ;
           got_channel = 0 ; 
           strcpy(devtable[MAXDEV].widz_essid ,driver_essid);
           sprintf(devtable[MAXDEV].widz_mac,"%s", driver_mac);
           devtable[MAXDEV].widz_channel = channel;
           devtable[MAXDEV].widz_signal =  driver_signal;
           MAXDEV++                            ;
           }
	}
	while(ret > 0);

  return(0);
}



/**************************************************
                        
 **************************************************/

int 
reset_essid(int sock, const char *ifname)
{
  char essid_buf[IW_ESSID_MAX_SIZE + 1];
  struct iwreq wrq;
  if ( DEBUG )
      fprintf(stderr, "Function:  %s \n", __FUNCTION__);
    
	

  memset(&wrq, 0, sizeof(wrq));
  memset(essid_buf, 0, sizeof(essid_buf));
    wrq.u.essid.flags = 0;
  strcpy(wrq.ifr_name, ifname);

  strcpy(essid_buf, "");
  wrq.u.essid.flags = 0;
  wrq.u.essid.pointer = (caddr_t) essid_buf;
  wrq.u.essid.length = strlen(essid_buf) + 1;

  if(ioctl(sock, SIOCSIWESSID, &wrq) < 0) {
    return 0;
  }

  return 1;
}

/**************************************************
                        
 **************************************************/


 // clean subroutine a botch to remove shell escapes designed to remove
char * cleanit (  char * clean)
{
char * temp_ptr;
        if ( DEBUG )
            fprintf(stderr, "Function:  %s \n", __FUNCTION__);
    
 
	while ( (temp_ptr = strpbrk( clean, ";'&!`)") ) )
	{
	*temp_ptr = '.';
	}

	return clean;
	}
	


/**************************************************
                        
 **************************************************/


do_alert(char *target)
  {
  char mess[100];
        if ( DEBUG )
            fprintf(stderr, "Function:  %s \n", __FUNCTION__);
   if ( daemon_mode == 0)
      fprintf(stderr,  target     );  
  else
      syslog(LOG_WARNING,"%s", target     );  
  setenv ("WIDZMSG", target,1);
  return;   // do not call scripts
  system("Alert");
  }



/**************************************************
                        
 **************************************************/

 
void
monitor_mode()
  {
  int signal=0;
  char target[100];
  int i;
  for (i=0; MAXDEV > i ; i++)
    {
    if ( DEBUG )
      {
      printf("Debug monitor_mode() -Does %s match pattern >",(char *) target );
	printf("%s < stored in database index # %i\n", pattern[i], i);
       }
    //
     memset(target,  0 , 100 );
int x = findintable(devtable[i].widz_essid);
if ( x == -1 )
{
       sprintf( target,
              "Alert unknown AP essid=%s ap_mac=%s stored ap = %s \n",
          devtable[i].widz_essid , devtable[i].widz_mac , "unknown mac" ) ;      
     do_alert(target);
continue ;
}

if ( strcmp( aptable[x].widz_mac, devtable[i].widz_mac ) != 0 )
{
       sprintf( target,
              "Alert unknown AP essid=%s ap_mac=%s stored mac = %s \n",
     devtable[i].widz_essid , devtable[i].widz_mac , aptable[x].widz_mac ) ;      
     do_alert(target);
continue ;
    }
         
 signal = aptable[x].widz_signal * SIGNAL_OVERPOWER; //20 percent margin of error
 if (signal < devtable[i].widz_signal)
    {
       sprintf( target,
              "Alert  AP essid=%s ap_mac=%s recorded signal= %i \n",
          devtable[i].widz_essid , devtable[i].widz_mac, devtable[i].widz_signal);
       do_alert(target);
continue ;
      }

if (  aptable[x].widz_channel != devtable[i].widz_channel ) 
{
       sprintf( target,
              "Alert AP essid=%s ap_mac=%s now on channel = %i \n",
     devtable[i].widz_essid , devtable[i].widz_mac , devtable[x].widz_channel);    
     do_alert(target);
continue ;
    }

     if ( DEBUG )
	printf("Debug - No  match \n" );
      }
    // do_alert(target);
         
}

/**************************************************
 Load memory            
 **************************************************/
void 
loadpattern() 
  {
  char target[100];
  int i;
  if ( DEBUG )
     fprintf(stderr, "Function:  %s \n", __FUNCTION__);

  if ( (ff=fopen(CONF_FILE,"r")) == NULL )
        {
        perror("file");
        fprintf(stderr, "Error opening:  %s \n", CONF_FILE);
        exit(1);
        }
  for (i=0; i < MAXAP; i++)
     {
     if ( fgets(target, 80 , ff) == NULL )
        {
        MAXAP=i;
        count = i;
        return ;
        }
      sscanf(target,"essid=%s ap_mac=%s channel=%i signal=%i\n",
         aptable[i].widz_essid,
         aptable[i].widz_mac,
         &aptable[i].widz_channel,
         &aptable[i].widz_signal );
      if ( DEBUG )
         printf("Debug: Loadpattern() loading index# %i with  pattern=%s \n",i, (char *)pattern[i]) ;
     }
  }


/**************************************************
 printtable   
 **************************************************/
void
 printtable(int n, FILE *FP)
  {
  int i;
  if ( n != -1 )
     {
      i = n;
  fprintf(FP, "essid=%s ap_mac=%s channel=%i signal=%i\n",
aptable[i].widz_essid,
aptable[i].widz_mac,
aptable[i].widz_channel,
aptable[i].widz_signal );
  return;
     }
   for (i=0; i < MAXAP; i++)
     {
 fprintf(FP,
     "essid=%s ap_mac=%s channel=%i signal=%i\n",
aptable[i].widz_essid,
aptable[i].widz_mac,
aptable[i].widz_channel,
aptable[i].widz_signal );
     }
  }




/**************************************************

 **************************************************/
void
 resetdevtable()
  {
  int i;
  if ( DEBUG )
     fprintf(stderr, "Function:  %s \n", __FUNCTION__);
  
   for (i=0; i < MAXDEV; i++)
      {                     
      memset( devtable[i].widz_essid , '\0', 16);
      memset(devtable[i].widz_mac, '\0', 16);
      devtable[i].widz_channel = 0;
      devtable[i].widz_signal = 0 ;
      }
}

/**************************************************
 printdevtable   
 **************************************************/
void
 printdevtable( FILE *FP)
  {
  int i;
  int rc;
  if ( DEBUG )
     fprintf(stderr, "Function:  %s \n", __FUNCTION__);
   for (i=0; i < MAXDEV; i++)
     {
     rc=fprintf(FP,
     "essid=%s ap_mac=%s channel=%i signal=%i\n",
      devtable[i].widz_essid,
      devtable[i].widz_mac,
      devtable[i].widz_channel,
      devtable[i].widz_signal );
      if( rc < 0 )
         {
         fprintf(stderr,"in printdevtable \n");
          ferror(FP);
         exit(1);
       }
     }
  }


/**************************************************
                        
 **************************************************/

int
findintable(char *needle)
  {
  int i;
   for (i=0; i < MAXAP; i++)
     {
//
  if (strcmp( aptable[i].widz_essid,needle) == 0)
 return(i);
     }
 return(-1 );

  }



/**************************************************
Get ESSID name from  interface 
 **************************************************/


char * get_essid(int sock, const char *ifname)
 {
  struct iwreq          wrq;
  struct wireless_info  info_local, *info = &info_local;
  char   essid_buf[IW_ESSID_MAX_SIZE + 1];
  memset(essid_buf, 0, sizeof(essid_buf));
  memset(info, 0, sizeof(struct wireless_info));
  memset(&wrq, 0, sizeof(wrq)); // Get ESSID 
  strcpy(wrq.ifr_name, ifname);
  wrq.u.essid.pointer = (caddr_t) essid_buf;
  wrq.u.essid.length = 19;    //kak
  wrq.u.essid.flags = 0;
  if(ioctl(sock, SIOCGIWESSID, &wrq) >= 0) {
//    info->has_essid = 1;
//    info->essid_on = wrq.u.data.flags;
  } else {
    fprintf(stderr, "SIOCGIWESSID: %s\n", strerror(errno));
  }
  return strdup(essid_buf);
}


/**************************************************
Get AP MAC  from  interface 
 **************************************************/

char *get_ap(int sock, const char *ifname)
{
  struct iwreq		wrq;
  struct wireless_info  info_local, *info = &info_local;

  memset(info, 0, sizeof(struct wireless_info));
  memset(&wrq, 0, sizeof(wrq));

  strcpy(wrq.ifr_name, ifname);

  if(ioctl(sock, SIOCGIWAP, &wrq) >= 0) {
    info->has_ap_addr = 1;
    memcpy(&(info->ap_addr), &(wrq.u.ap_addr), sizeof (sockaddr));
  }

  if(strcmp(info->ap_addr.sa_data, "DDDDDD") == 0) {

    return NULL;
  }
   
  return( macit(info->ap_addr.sa_data));
  // 
}

  


/**************************************************
 some global definitions 
 **************************************************/


/***************************************************************************
 
 ***************************************************************************/
/* 
   Function : look
   Open socket, schedule scan, get scan , process scan
 
 ***************************************************************************/

void look()
{

  int sock = socket(AF_INET, SOCK_DGRAM, 0);
  int i  = 0 ;
  struct iwreq		wrq_1;
        if ( DEBUG )
     fprintf(stderr,"in looke \n");
  //   get essid  
           got_channel= 0 ;
           got_signal = 0 ;
           got_mac = 0 ;
           got_essid = 0   ;
i = schedule_scan( sock, wdev   ) ;
i =   get_scan( sock, wdev , &wrq_1);
//int get_scan(int skfd, char* ifname, struct iwreq* wrq)
  // essid =get_essid(sock, wdev   ) ;
print_scan_results(  &wrq_1, wdev );
//print_scan_results(struct iwreq* wrq, char* ifname)
  close(sock);
     
return;
}

/* unused code from widz 1.8 */
void monitorx()
{
  //   get essid  
/*
   if ( essid == NULL  )
	     break;
     if ( ap == NULL )
     {
        if ( DEBUG )
             printf("Debug look() essid=%s ap_mac is null \n",essid );
	     break;
     }

     if ( DEBUG )
          printf("Debug look() essid=%s ap_mac=%s index %i\n",essid ,  ap, i);
      
     // null mac address                                          
     if ( strstr(ap_store,temp) != NULL )
     {
	     break;
     }
*/
  
}


#include <sys/file.h>

// *********************************************************
// **  pidfile()
// *********************************************************
void pidfile()
{
  FILE *ff;
  int  ffint;
  int  x;
  char pidfile[100];
#define RUNDIR             "/var/run/"

if ( DEBUG )
   fprintf(stderr, "Function:  %s \n", __FUNCTION__);


sprintf(pidfile,"%s%s.pid",RUNDIR,instancename);
   fprintf(stderr, "pidfile :  %s \n", pidfile     );
fprintf(stderr, "%i \n", getpid());

if ( (ff=fopen(pidfile,"r")) == NULL )
   {
// file does not exists
   }
else
   {  // if the file exists test for lock
   ffint = fileno(ff);
   x = flock(ffint, LOCK_EX|LOCK_NB);
   if ( x < 0 )
      {
      syslog(LOG_WARNING, "file lock fail");
      perror("file lock fail");
      exit(1);
      }
  fclose(ff);
  }
	
	
// *********************************************************
// ***   
// *********************************************************
if ( (ff=fopen(pidfile,"w")) == NULL )
   {
   perror("file widz_apemon.pid");
   exit(1);
   }
fprintf(ff    , "%i \n", getpid());
fflush(ff);
fclose(ff);

// *********************************************************
// ***   
// *********************************************************

if ( (ff=fopen(pidfile,"r")) == NULL )
{
// file does not exists
perror("file widz_apmon.pid");
exit(1); // cant happen 
}
// if the file exists test for lock
ffint = fileno(ff);
x = flock(ffint, LOCK_EX|LOCK_NB);
if ( x < 0                             )
{
perror("file widz_apmon.pid lock fail");
exit(1) ; // very remote chance of a race condition
}
 //  do not close hold the lock   fclose(ff);

fprintf(stderr, "ending functionmesg_text: \n");
fflush(stderr);
	
}
/**************************************************
 * 
 ************************************************/
#define PROGNAME          "widz_apmon"
/**************************************************
 * 
 ************************************************/

//
// change_dir
//
change_dir()
{
if ( DEBUG )
        fprintf(stderr, "Function:  %s \n", __FUNCTION__);

#define CWD  "/usr/local/etc/widz/widz_apmon"
int nl = 0;			/* number  */
char buffy[100];
nl =chdir(CWD);
if ( nl   < 0          )
   {
      fprintf (stderr, "rc %i  failed to cd %s  \n", nl , CWD    );
perror("CWD");
      exit(1);
   }
// 
getcwd(buffy,100);
fprintf (stderr, "Using paramters in %s \n", buffy  );
}


/**************************************************
useage
 **************************************************/


usage(){
fprintf(stderr,"widz_apmon int_sleeptime device  [monitor | generate] [-D]\n ");
		exit(1);
}
/**************************************************
 Main               
 **************************************************/
int
main(int argc, char *argv[])
 {
 DEBUG = 0;


  // set debug flag
  //
 if ( getenv("DEBUG")  )
      DEBUG = 1;
//   Should use getopts but i hate it
  if (argc <  4 )
     {
     fprintf(stderr,"wrong num of args %i \n", argc);
     usage();
     exit(1);
     }


  strcpy(wdev,argv[2]);

if( atoi(argv[1]) == 0)
    {
   fprintf(stderr,"ARG 1 is wait time   \n");
   usage();
     exit(1);
    }
 
  sleeptime=atoi(argv[1]);
//
//Generate a file full of local Access Points
//
  if (strcmp("generate",argv[3]) == 0)
      {
     fprintf(stderr,"generate \n");
     if ( (YY=fopen(CONF_FILE,"w")) == NULL )
        {
        perror("file");
        exit(1);
        }
// 
//    build config pattern
// 
     look();
     printdevtable(stdout);
     printdevtable(YY);
     fclose(YY);
     fprintf(stdout,"Config file generated \n");
     exit(1);
}
sprintf(instancename,"%s_%s",PROGNAME, wdev   )   ;


//     It must be "monitor mode"

if ( strcmp("monitor",argv[3]) != 0)
   {
   fprintf(stderr,"command mustx be monitor or generate \n");
   usage() ;
   exit(1);
   }
//     It must be "monitor mode"
//   Should use getopts but i hate it
  if (argc ==  5 )
     {
     if ( strcmp("-D",argv[4]) == 0)
        {
        daemon_mode = 1 ; // YESSS            
        }
      else
        {
        fprintf(stderr,"last parm must be -D                 \n");
        usage() ;
        exit(1);
        }
     }
       
  if ( (daemon_mode == 1) && (DEBUG == 1 )) 
   {
   fprintf(stderr,"DAEMON MODE not allowedwith DEBUG  \n");
   fprintf(stderr,"DEBUG DISAABLED  \n");
   }       
// 
change_dir();

// load config file
loadpattern();
printtable(-1, stderr);

  if ( daemon_mode == 0)  
    {
    printtable(-1, stdout);
    }
  else
    {
    if (daemon(0,0) != 0)
      {
      fprintf(stdout,"error in DAEMON       \n");
      perror("daemon");
      exit(1);
       }
    openlog(instancename , LOG_PERROR|LOG_NDELAY, LOG_AUTHPRIV);
    syslog(LOG_WARNING, "STARTING SYSLOG stream" );  
    pidfile();
    }


while(1)
  {
  resetdevtable();
  sleep(sleeptime);
  look();
  if ( DEBUG )
     printdevtable(stderr);
  monitor_mode();
 //system("Controlexit");
//     Control exit - call to routine that checks for probe frames
       
   }
}
