#!/bin/sh

### BEGIN INIT INFO
# Provides:		widz_apmon
# Required-Start:	
# Required-Stop:	
# Should-Start:		
# Should-Stop:
# Default-Start:	2 3 4 5
# Default-Stop:		0 1 6
# Short-Description:	IEEE 802.11 apmon ids daemon
# Description:		IEEE 802.11 apmon ids daemon
#			monitors for access points 
### END INIT INFO

PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/bin
DAEMON_SBIN=/usr/local/bin/widz_apmon
DAEMON_DEFS=
DAEMON_CONF==/usr/local/etc/widz/widz_apmon
NAME=widz_apmon
DESC="advanced IEEE 802.11 IDS"
PIDFILE=/var/run/widz_apmon_wlan2.pid

[ -x "$DAEMON_SBIN" ] || exit 0


. /lib/lsb/init-functions

case "$1" in
  start)
	log_daemon_msg "Starting $DESC" "$NAME"
	$DAEMON_SBIN 30 wlan2 monitor -D
	log_end_msg "$?"
	;;
  stop)
	log_daemon_msg "Stopping $DESC" "$NAME"
        /bin/kill `cat $PIDFILE`
	log_end_msg "$?"
	;;
  restart|force-reload)
  	$0 stop
	sleep 8
	$0 start
	;;
  status)
	status_of_proc "$DAEMON_SBIN" "$NAME"
	exit $?
	;;
  *)
	N=/etc/init.d/$NAME
	echo "Usage: $N {start|stop|reload|status}" >&2
	exit 1
	;;
esac

exit 0
