//  Widz_apmon.c
// 
//  This is a hacked version of the Marveloud Wlansniff
//  from the really good HOSTAp driver 
//  it provides the data for
//  Widz_apmon.c
/*
 * Wireless LAN (IEEE 802.11) link-layer frame sniffer
 * Copyright (c) 2001-2002, SSH Communications Security Corp
 * Jouni Malinen <jkm@ssh.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <asm/types.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>   /* The L2 protocols */
#include <linux/if_arp.h>

#include "ieee80211.h"
#include "widz.h"

int verbose  = 0;
#include <fcntl.h>
#include <pcap.h>
#include <ctype.h>
#include <errno.h>
#include <sys/types.h>

#include <sys/syslog.h>

//* #define __USE_BSD
#include <netinet/in.h>
#include <netinet/ip.h>
#define __FAVOR_BSD
#include <netinet/udp.h>
#include <arpa/inet.h>
#include <signal.h>
#include <time.h>
#define _GNU_SOURCE
#include <string.h>

#define DEBUGIT(xxxx)           if ( debug == 1 ) printf(xxxx);

#define           MAXLOOP  9999                   

extern int DEBUG   ;
int snap_len;
#include <sys/ioctl.h>
#include <arpa/inet.h>

char dev[30]   ; /* pcap name */

static int current_channel=0;

pcap_t *handle;			/* packet capture handle */
//
#include <time.h>
#include <sys/time.h>
 struct tm *timep;
  struct timeval ts;

  time_t  otime;

widz_hdr_t widz_hdr;
frame_control_t *fc1 ;
void init();

    int incrementor = 1;
/*
 *	for dumping the frame in hex
 */
/*
 *	for dumping the frame in hex
 */
char dummybuf[20];
char *
hexdump (__u8 * x, int y)
{
  int i = -1;
if ( DEBUG )
        fprintf(stderr, "Function:  %s \n", __FUNCTION__);

  while (++i < y)
    sprintf (&dummybuf[(i * 2)], "%02x", x[i]);
  return (dummybuf);
}

// 

char daemonflag  ;
// 

/* prismprint.c */
void probe_mon();
void summary_alert();
void pidfile();

/* management.c */
int show_frame_management(unsigned int subtype, unsigned char *pos, int len);
/* chanchan.c */
int hop_channel(char *iface, int chan);
int getifflags(char *iface);



enum { BEACONS_NO, BEACONS_ONE_LINE, BEACONS_FULL };
int show_beacons = BEACONS_NO;
int show_only_authen = 0;
int pcap_count       = 0;


const char *mac2str(unsigned char *addr)
{
if ( DEBUG )
        fprintf(stderr, "Function:  %s \n", __FUNCTION__);

	static char buf[20];
	snprintf(buf, sizeof(buf), "%02x:%02x:%02x:%02x:%02x:%02x",
		 addr[0], addr[1], addr[2], addr[3], addr[4], addr[5]);
	return buf;
}


struct addr_titles {
	char *a1, *a2, *a3, *a4;
};

static struct addr_titles titles[] = {
	{"DA", "SA", "BSSID", NULL},
	{"DA", "BSSID", "SA", NULL},
	{"BSSID", "SA", "DA", NULL},
	{"RA", "TA", "DA", "SA"}};



void handle_wlansniffrm(unsigned char *buf, int len, int prism_header)
{
	struct hfa384x_rx_frame frmbuf, *frm;
	int left, used, hdrlen;
	unsigned char *pos;
	unsigned int fc;

if ( DEBUG )
        fprintf(stderr, "Function:  %s \n", __FUNCTION__);

	left = len;
	pos = buf;

        widz_hdr.ssid_len =  0           ;
        memset ( &widz_hdr.SSID  , "\0", SSID_SIZE);
        memset ( widz_hdr.mac1,   0,       6);
        memset ( widz_hdr.mac2,   0,       6);
        memset ( widz_hdr.mac3,   0,       6);
        memset ( widz_hdr.mac4,   0,       6);

       frm = (struct hfa384x_rx_frame *) (buf - 14);

	widz_hdr.frame_control = le_to_host16(frm->frame_control);
	fc = le_to_host16(frm->frame_control);
	hdrlen = 24;
	switch (WLAN_FC_GET_TYPE(fc)) {
	case WLAN_FC_TYPE_DATA:
		if ((fc & WLAN_FC_FROMDS) && (fc & WLAN_FC_TODS))
			hdrlen = 30; /* Addr4 */
		        memcpy( widz_hdr.mac4,&frm->addr4,6);
		break;
	case WLAN_FC_TYPE_CTRL:
		switch (WLAN_FC_GET_STYPE(fc)) {
		case WLAN_FC_STYPE_CTS:
		case WLAN_FC_STYPE_ACK:
			hdrlen = 10;
			break;
		default:
			hdrlen = 16;
			break;
			}
		break;
	}

	if (left < hdrlen) {
	        fprintf(stderr, "Too short (left=%d < hdrlen=%d)\n",
		       left, hdrlen);
		return;
	}

	left -= hdrlen;
	pos += hdrlen;


	gettimeofday(&widz_hdr.ts,NULL);
	widz_hdr.timep=gmtime( &widz_hdr.ts.tv_sec);
	memcpy( widz_hdr.mac1,&frm->addr1,6);
	memcpy( widz_hdr.mac2,&frm->addr2,6);
	memcpy( widz_hdr.mac3,&frm->addr3,6);

//****************************************

	switch (WLAN_FC_GET_TYPE(fc)) {
	case WLAN_FC_TYPE_DATA:
		// show_hdr_data(frm);
		break;
	case WLAN_FC_TYPE_MGMT:
		// show_hdr_management(frm);
		break;
	case WLAN_FC_TYPE_CTRL:
		switch (WLAN_FC_GET_STYPE(fc)) {
		case WLAN_FC_STYPE_PSPOLL:
			// show_hdr_pspoll(frm);
			break;
		case WLAN_FC_STYPE_RTS:
	//		show_hdr_rts(frm);
			break;
		case WLAN_FC_STYPE_CFEND:
		case WLAN_FC_STYPE_CFENDACK:
			// show_hdr_cfend(frm);
			break;
		case WLAN_FC_STYPE_CTS:
		case WLAN_FC_STYPE_ACK:
			// show_hdr_cts(frm);
			break;
		}
		break;
	}

	used = 0;
	switch (WLAN_FC_GET_TYPE(fc)) {
	case WLAN_FC_TYPE_MGMT:
  		used = show_frame_management(WLAN_FC_GET_STYPE(fc), pos, left);
		break;
	}
	pos += used;
	left -= used;


}

//
// reporting data
//
void
proc_packet (u_char * args, const struct pcap_pkthdr *header,
		 const u_char * packet)
{
if ( DEBUG )
        fprintf(stderr, "Function:  %s \n", __FUNCTION__);

// reset alarm every record so timer is from last record
// not session 
//  MAYBE set_timeout();

if (pcap_count >  MAXLOOP )
    {
    pcap_breakloop(handle);
    }
    pcap_count = pcap_count +     incrementor ;
  /* BUILD WIDZ_HDR structure  */
    handle_wlansniffrm(packet+18, header->caplen,0); 
  /* Analyse WIDZ_HDR for alerts       */
    probe_mon();
      return;

    }

// 
// 
// 
#define            MAX_SCAN_CHANNEL       20
extern int     no_input_channels;           
extern int scan_channel[MAX_SCAN_CHANNEL] ;      
// 
// 
// 
//

char errbuf[PCAP_ERRBUF_SIZE];	/* error buffer */
char filter_exp[120] = "\0               ";
sniffer2(const char *iface)
{
  int n = 0;			/* number  */
int channel[5] = { 1,3,10,13};
if ( DEBUG )
        fprintf(stderr, "Function:  %s \n", __FUNCTION__);

  snap_len = 1500         ;
  while (1)
   {
    pcap_count= 0;
  if (  strstr(dev,".pcap")  == NULL)
    {
    handle = pcap_open_live (dev, snap_len, 1, 1, errbuf);
    incrementor=0  ;    // make sooooooo never excede count
    }
       else
    {
    handle = pcap_open_offline (dev    , errbuf);
    incrementor = 1;
    }
  if (handle == NULL)
    {
      fprintf (stderr, "Couldn't open file %s: %s\n", dev, errbuf);
      exit (EXIT_FAILURE);
    }
//            
current_channel++    ;
// reset to first channel if the current pointer greater than # input
if ( current_channel >   no_input_channels  )
     current_channel = 0 ;
// reset to first channel if the next value is 0
if (  scan_channel[current_channel] == 0 )                 
     current_channel = 0 ;
// hop channels if the first posittion in array set 
if (  no_input_channels > 0 || scan_channel[0] > 0 )                 
{
printf( "channel=%i   \n  ", scan_channel[current_channel]);
hop_channel(dev, scan_channel[current_channel]);
}

set_timeout();
  pcap_loop (handle, (int) 0000, proc_packet, NULL);
  pcap_close(handle);                 
//*   
  summary_alert();
  printf ("I have done XXX packetson on channel  or timed out \n");
  fflush (stdout);
  }
}


 /****************************************************************************  */
//
// change_dir
//
change_dir()
{
if ( DEBUG )
        fprintf(stderr, "Function:  %s \n", __FUNCTION__);

#define CWD  "/usr/local/etc/widz/widz_probemon"
int nl = 0;			/* number  */
char buffy[100];
nl =chdir(CWD);
if ( nl   < 0          )
   {
      fprintf (stderr, "rc %i  failed to cd %s  \n", nl , CWD    );
perror("CWD");
      exit(1);
   }
chdir(dev);
// dont care if the cd works - will default o
// to file in widz/widz_probemon
getcwd(buffy,100);
fprintf (stderr, "Using paramters in %s \n", buffy  );
}

/**************************************************
usage
 **************************************************/


usage(){
if ( DEBUG )
        fprintf(stderr, "Function:  %s \n", __FUNCTION__);

fprintf(stderr,"widz_probemon device [-d]");
                exit(1);
}


/**************************************************
int main()

 **************************************************/
int main(int argc, char *argv[])
{
	int i;
	const char *iface = NULL;



 // set debug flag
  //
if ( getenv("DEBUG")  )
      DEBUG = 1;

if ( DEBUG )
        fprintf(stderr, "Function:  %s \n", __FUNCTION__);

fc1 = (frame_control_t *) &widz_hdr.frame_control;
   

     fprintf(stderr, "argc    :  %i \n", argc        );

if( argc  < 2  || argc > 3 )
{
            usage();                   
}
iface = argv[1];
strcpy(dev,iface);
getifflags(dev);
change_dir();
//
//purposely validate parms before going daemon
// when stderr will be disabled
//

#define PROGNAME          "widz_probemon"
extern char instancename[30]   ;
sprintf(instancename,"%s_%s",PROGNAME, dev   )   ;
	init();
if( argc == 3)
      {
	if  (   argv[2][1] == 'd' )
             daemonflag ='d';
        else
            usage();                   
      }

if  (  daemonflag  == 'd' )
    {
    i =    daemon(0,0)    ;
    if  (  i           == -1  )
      {                           
      fprintf(stderr,"daemon system call failled             ");
      exit(1);
      }

    pidfile();

    }


// rewrite sniffer2 is the sequel
	sniffer2(iface);
	// sniffer(iface);
	return 0;
}
